#include <STC32G.H>

//sbit CLK=P2^5;
//sbit SDO=P2^4;
//sbit SDI=P2^3;
//sbit CS=P2^2;
sbit CLK=P6^6;
sbit SDO=P6^5;
sbit SDI=P6^4;
sbit CS=P4^0;

const float Rt=430;  // οֵ

void MAX31865_write(unsigned char command)
{
	unsigned char i=0;
	unsigned char da=0x00;
	CS=0;
	CLK=0;
	for(i=0;i<8;i++)
	{
		SDI=0x80&(0x80>>i);
		CLK=1;
		CLK=0;
	}
	
	for(i=0;i<8;i++)
	{
		SDI=command&(0x80>>i);
		CLK=1;
		CLK=0;
	}
	CLK=1;
	CS=1;
}

unsigned char MAX31865_read(unsigned char add)
{
	unsigned char i=0;
	unsigned char da=0x00;
	CS=0;
	CLK=0;
	
	for(i=0;i<8;i++)
	{
		SDI=add&(0x80>>i);
		CLK=1;
		CLK=0;
	}
	for(i=0;i<8;i++)
	{
		if(SDO){da|=(0x80>>i);}
		CLK=1;
		CLK=0;
	}
	CLK=1;
	CS=1;
	return da;
}	

unsigned int get_ad(void)
{
	unsigned char i=0;
	unsigned char a=0,b=0;
	unsigned int result=0;
	
	MAX31865_write(0xC1);  //2, 4
	//MAX31865_write(0xD1);  //3
	a=MAX31865_read(0x01);
	b=MAX31865_read(0x02);
	result=a<<8|b;
	result>>=1;

	return result;
}

float get_t(void)
{
	float T=0,R=0;
	unsigned int ADvalue=0;
	ADvalue=get_ad();
	R=ADvalue*(Rt/32768);
	if(R>=100)
	{
		T=(R-100)/0.385;
	}else
	{
		T=(R-100)/0.4074;
	}
	return T;
}

